/* rygel-mediathek-asx-playlist.c generated by valac 0.9.5, the Vala compiler
 * generated from rygel-mediathek-asx-playlist.vala, do not modify */

/*
 * Copyright (C) 2009 Jens Georg
 *
 * Author: Jens Georg <mail@jensge.org>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <libsoup/soup.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/xpath.h>


#define RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST (rygel_mediathek_asx_playlist_get_type ())
#define RYGEL_MEDIATHEK_ASX_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST, RygelMediathekAsxPlaylist))
#define RYGEL_MEDIATHEK_ASX_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST, RygelMediathekAsxPlaylistClass))
#define RYGEL_MEDIATHEK_IS_ASX_PLAYLIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST))
#define RYGEL_MEDIATHEK_IS_ASX_PLAYLIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST))
#define RYGEL_MEDIATHEK_ASX_PLAYLIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST, RygelMediathekAsxPlaylistClass))

typedef struct _RygelMediathekAsxPlaylist RygelMediathekAsxPlaylist;
typedef struct _RygelMediathekAsxPlaylistClass RygelMediathekAsxPlaylistClass;
typedef struct _RygelMediathekAsxPlaylistPrivate RygelMediathekAsxPlaylistPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _xmlXPathFreeContext0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeContext (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR_XML_ERROR,
	RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR_NETWORK_ERROR
} RygelMediathekAsxPlaylistError;
#define RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR rygel_mediathek_asx_playlist_error_quark ()
struct _RygelMediathekAsxPlaylist {
	GObject parent_instance;
	RygelMediathekAsxPlaylistPrivate * priv;
	GeeArrayList* uris;
};

struct _RygelMediathekAsxPlaylistClass {
	GObjectClass parent_class;
};

struct _RygelMediathekAsxPlaylistPrivate {
	char* uri;
};


static gpointer rygel_mediathek_asx_playlist_parent_class = NULL;

GQuark rygel_mediathek_asx_playlist_error_quark (void);
GType rygel_mediathek_asx_playlist_get_type (void) G_GNUC_CONST;
#define RYGEL_MEDIATHEK_ASX_PLAYLIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST, RygelMediathekAsxPlaylistPrivate))
enum  {
	RYGEL_MEDIATHEK_ASX_PLAYLIST_DUMMY_PROPERTY
};
RygelMediathekAsxPlaylist* rygel_mediathek_asx_playlist_new (const char* uri);
RygelMediathekAsxPlaylist* rygel_mediathek_asx_playlist_construct (GType object_type, const char* uri);
void rygel_mediathek_asx_playlist_parse (RygelMediathekAsxPlaylist* self, GError** error);
static void rygel_mediathek_asx_playlist_finalize (GObject* obj);



GQuark rygel_mediathek_asx_playlist_error_quark (void) {
	return g_quark_from_static_string ("rygel_mediathek_asx_playlist_error-quark");
}


#line 46 "rygel-mediathek-asx-playlist.vala"
RygelMediathekAsxPlaylist* rygel_mediathek_asx_playlist_construct (GType object_type, const char* uri) {
#line 96 "rygel-mediathek-asx-playlist.c"
	RygelMediathekAsxPlaylist * self;
	GeeArrayList* _tmp0_;
	char* _tmp1_;
#line 46 "rygel-mediathek-asx-playlist.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 46 "rygel-mediathek-asx-playlist.vala"
	self = (RygelMediathekAsxPlaylist*) g_object_new (object_type, NULL);
#line 47 "rygel-mediathek-asx-playlist.vala"
	self->uris = (_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL), _g_object_unref0 (self->uris), _tmp0_);
#line 48 "rygel-mediathek-asx-playlist.vala"
	self->priv->uri = (_tmp1_ = g_strdup (uri), _g_free0 (self->priv->uri), _tmp1_);
#line 108 "rygel-mediathek-asx-playlist.c"
	return self;
}


#line 46 "rygel-mediathek-asx-playlist.vala"
RygelMediathekAsxPlaylist* rygel_mediathek_asx_playlist_new (const char* uri) {
#line 46 "rygel-mediathek-asx-playlist.vala"
	return rygel_mediathek_asx_playlist_construct (RYGEL_MEDIATHEK_TYPE_ASX_PLAYLIST, uri);
#line 117 "rygel-mediathek-asx-playlist.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
#line 1166 "glib-2.0.vapi"
	return result;
#line 127 "rygel-mediathek-asx-playlist.c"
}


/** 
     * Get and parse the ASX file.
     *
     * This will fetch the ASX file represented by an uri
     * using a synchronous soup session. As ASX seems to be
     * a bit inconsistent wrt tag case all the tags are
     * converted to lowercase. A XPath query is then used
     * to extract all of the href attributes for every entry
     * in the file
     */
#line 61 "rygel-mediathek-asx-playlist.vala"
void rygel_mediathek_asx_playlist_parse (RygelMediathekAsxPlaylist* self, GError** error) {
#line 143 "rygel-mediathek-asx-playlist.c"
	GError * _inner_error_;
	SoupSessionSync* session;
	SoupMessage* message;
	guint _tmp0_;
#line 61 "rygel-mediathek-asx-playlist.vala"
	g_return_if_fail (self != NULL);
#line 150 "rygel-mediathek-asx-playlist.c"
	_inner_error_ = NULL;
#line 63 "rygel-mediathek-asx-playlist.vala"
	session = (SoupSessionSync*) soup_session_sync_new ();
#line 64 "rygel-mediathek-asx-playlist.vala"
	message = soup_message_new ("GET", self->priv->uri);
#line 67 "rygel-mediathek-asx-playlist.vala"
	soup_session_send_message ((SoupSession*) session, message);
#line 68 "rygel-mediathek-asx-playlist.vala"
	if ((g_object_get (message, "status-code", &_tmp0_, NULL), _tmp0_) == 200) {
#line 160 "rygel-mediathek-asx-playlist.c"
		{
			GRegex* normalizer;
			char* normalized_content;
			xmlDoc* doc;
#line 71 "rygel-mediathek-asx-playlist.vala"
			normalizer = g_regex_new ("(<[/]?)([a-zA-Z:]+)", 0, 0, &_inner_error_);
#line 167 "rygel-mediathek-asx-playlist.c"
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch0_g_regex_error;
				}
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
#line 73 "rygel-mediathek-asx-playlist.vala"
			normalized_content = g_regex_replace (normalizer, (const char*) message->response_body->data, (gssize) ((glong) message->response_body->length), 0, "\\1\\L\\2\\E", 0, &_inner_error_);
#line 180 "rygel-mediathek-asx-playlist.c"
			if (_inner_error_ != NULL) {
				_g_regex_unref0 (normalizer);
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch0_g_regex_error;
				}
				_g_regex_unref0 (normalizer);
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
#line 78 "rygel-mediathek-asx-playlist.vala"
			doc = xmlParseMemory (normalized_content, (gint) string_get_length (normalized_content));
#line 81 "rygel-mediathek-asx-playlist.vala"
			if (doc != NULL) {
#line 197 "rygel-mediathek-asx-playlist.c"
				xmlXPathContext* ctx;
				xmlXPathObject* xpo;
#line 82 "rygel-mediathek-asx-playlist.vala"
				ctx = xmlXPathNewContext (doc);
#line 83 "rygel-mediathek-asx-playlist.vala"
				xpo = xmlXPathEval ("/asx/entry/ref/@href", ctx);
#line 84 "rygel-mediathek-asx-playlist.vala"
				if (xpo->type == XPATH_NODESET) {
#line 206 "rygel-mediathek-asx-playlist.c"
					{
						gint i;
#line 85 "rygel-mediathek-asx-playlist.vala"
						i = 0;
#line 211 "rygel-mediathek-asx-playlist.c"
						{
							gboolean _tmp1_;
#line 85 "rygel-mediathek-asx-playlist.vala"
							_tmp1_ = TRUE;
#line 85 "rygel-mediathek-asx-playlist.vala"
							while (TRUE) {
#line 218 "rygel-mediathek-asx-playlist.c"
								xmlNode* item;
#line 85 "rygel-mediathek-asx-playlist.vala"
								if (!_tmp1_) {
#line 85 "rygel-mediathek-asx-playlist.vala"
									i++;
#line 224 "rygel-mediathek-asx-playlist.c"
								}
#line 85 "rygel-mediathek-asx-playlist.vala"
								_tmp1_ = FALSE;
#line 85 "rygel-mediathek-asx-playlist.vala"
								if (!(i < xmlXPathNodeSetGetLength (xpo->nodesetval))) {
#line 85 "rygel-mediathek-asx-playlist.vala"
									break;
#line 232 "rygel-mediathek-asx-playlist.c"
								}
#line 86 "rygel-mediathek-asx-playlist.vala"
								item = xmlXPathNodeSetItem (xpo->nodesetval, i);
#line 87 "rygel-mediathek-asx-playlist.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) self->uris, item->children->content);
#line 238 "rygel-mediathek-asx-playlist.c"
							}
						}
					}
				}
				_xmlXPathFreeContext0 (ctx);
			} else {
				_inner_error_ = g_error_new_literal (RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR, RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR_XML_ERROR, "Could not fetch XML");
				{
					_g_free0 (normalized_content);
					_g_regex_unref0 (normalizer);
					if (_inner_error_->domain == G_REGEX_ERROR) {
						goto __catch0_g_regex_error;
					}
					goto __finally0;
				}
			}
			_g_free0 (normalized_content);
			_g_regex_unref0 (normalizer);
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
			GError * _error_;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			{
				_g_error_free0 (_error_);
			}
		}
		__finally0:
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				return;
			} else {
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	} else {
		guint _tmp2_;
		guint _tmp3_;
		_inner_error_ = g_error_new (RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR, RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR_NETWORK_ERROR, "Playlist download failed: %u (%s)", (g_object_get (message, "status-code", &_tmp2_, NULL), _tmp2_), soup_status_get_phrase ((g_object_get (message, "status-code", &_tmp3_, NULL), _tmp3_)));
		{
			if (_inner_error_->domain == RYGEL_MEDIATHEK_ASX_PLAYLIST_ERROR) {
				g_propagate_error (error, _inner_error_);
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				return;
			} else {
				_g_object_unref0 (message);
				_g_object_unref0 (session);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_g_object_unref0 (message);
	_g_object_unref0 (session);
}


static void rygel_mediathek_asx_playlist_class_init (RygelMediathekAsxPlaylistClass * klass) {
	rygel_mediathek_asx_playlist_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (RygelMediathekAsxPlaylistPrivate));
	G_OBJECT_CLASS (klass)->finalize = rygel_mediathek_asx_playlist_finalize;
}


static void rygel_mediathek_asx_playlist_instance_init (RygelMediathekAsxPlaylist * self) {
	self->priv = RYGEL_MEDIATHEK_ASX_PLAYLIST_GET_PRIVATE (self);
}


static void rygel_mediathek_asx_playlist_finalize (GObject* obj) {
	RygelMediathekAsxPlaylist * self;
	self = RYGEL_MEDIATHEK_ASX_PLAYLIST (obj);
	_g_object_unref0 (self->uris);
	_g_free0 (self->priv->uri);
	G_OBJECT_CLASS (rygel_mediathek_asx_playlist_parent_class)->finalize (obj);
}


/**
 * This class is a simple ASX playlist parser
 * 
 * It does nothing but extracting all href tags from an ASX
 * and ignore all of the other information that may be in it
 * 
 * This parser is //only// intended to work with the simple 
 * ASX files presented by the ZDF Mediathek streaming server
 */
GType rygel_mediathek_asx_playlist_get_type (void) {
	static volatile gsize rygel_mediathek_asx_playlist_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_mediathek_asx_playlist_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelMediathekAsxPlaylistClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_mediathek_asx_playlist_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelMediathekAsxPlaylist), 0, (GInstanceInitFunc) rygel_mediathek_asx_playlist_instance_init, NULL };
		GType rygel_mediathek_asx_playlist_type_id;
		rygel_mediathek_asx_playlist_type_id = g_type_register_static (G_TYPE_OBJECT, "RygelMediathekAsxPlaylist", &g_define_type_info, 0);
		g_once_init_leave (&rygel_mediathek_asx_playlist_type_id__volatile, rygel_mediathek_asx_playlist_type_id);
	}
	return rygel_mediathek_asx_playlist_type_id__volatile;
}




