/* rygel-connection-manager.c generated by valac 0.9.5, the Vala compiler
 * generated from rygel-connection-manager.vala, do not modify */

/*
 * Copyright (C) 2008 OpenedHand Ltd.
 * Copyright (C) 2008 Zeeshan Ali <zeenix@gmail.com>.
 *
 * Author: Jorn Baayen <jorn@openedhand.com>
 *         Zeeshan Ali <zeenix@gmail.com>
 *
 * This file is part of Rygel.
 *
 * Rygel is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Rygel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <libgupnp/gupnp.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define RYGEL_TYPE_CONNECTION_MANAGER (rygel_connection_manager_get_type ())
#define RYGEL_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManager))
#define RYGEL_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))
#define RYGEL_IS_CONNECTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_IS_CONNECTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), RYGEL_TYPE_CONNECTION_MANAGER))
#define RYGEL_CONNECTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), RYGEL_TYPE_CONNECTION_MANAGER, RygelConnectionManagerClass))

typedef struct _RygelConnectionManager RygelConnectionManager;
typedef struct _RygelConnectionManagerClass RygelConnectionManagerClass;
typedef struct _RygelConnectionManagerPrivate RygelConnectionManagerPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _RygelConnectionManager {
	GUPnPService parent_instance;
	RygelConnectionManagerPrivate * priv;
	char* sink_protocol_info;
	char* connection_ids;
	char* source_protocol_info;
	gint rcs_id;
	gint av_transport_id;
	char* direction;
};

struct _RygelConnectionManagerClass {
	GUPnPServiceClass parent_class;
};


static gpointer rygel_connection_manager_parent_class = NULL;

GType rygel_connection_manager_get_type (void) G_GNUC_CONST;
enum  {
	RYGEL_CONNECTION_MANAGER_DUMMY_PROPERTY
};
#define RYGEL_CONNECTION_MANAGER_UPNP_ID "urn:upnp-org:serviceId:ConnectionManager"
#define RYGEL_CONNECTION_MANAGER_UPNP_TYPE "urn:schemas-upnp-org:service:ConnectionManager:2"
#define RYGEL_CONNECTION_MANAGER_DESCRIPTION_PATH "xml/ConnectionManager.xml"
static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val);
static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val);
static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self);
static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val);
static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self);
static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action);
static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self);
static void rygel_connection_manager_real_constructed (GObject* base);
RygelConnectionManager* rygel_connection_manager_new (void);
RygelConnectionManager* rygel_connection_manager_construct (GType object_type);
static void rygel_connection_manager_finalize (GObject* obj);



#line 65 "rygel-connection-manager.vala"
static void _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self) {
#line 95 "rygel-connection-manager.c"
	rygel_connection_manager_query_source_protocol_info_cb (self, _sender, variable, value);
}


#line 72 "rygel-connection-manager.vala"
static void _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self) {
#line 102 "rygel-connection-manager.c"
	rygel_connection_manager_query_sink_protocol_info_cb (self, _sender, variable, value);
}


#line 79 "rygel-connection-manager.vala"
static void _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable (GUPnPService* _sender, const char* variable, GValue* value, gpointer self) {
#line 109 "rygel-connection-manager.c"
	rygel_connection_manager_query_current_connection_ids_cb (self, _sender, variable, value);
}


#line 86 "rygel-connection-manager.vala"
static void _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 116 "rygel-connection-manager.c"
	rygel_connection_manager_get_protocol_info_cb (self, _sender, action);
}


#line 94 "rygel-connection-manager.vala"
static void _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 123 "rygel-connection-manager.c"
	rygel_connection_manager_get_current_connection_ids_cb (self, _sender, action);
}


#line 101 "rygel-connection-manager.vala"
static void _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked (GUPnPService* _sender, GUPnPServiceAction* action, gpointer self) {
#line 130 "rygel-connection-manager.c"
	rygel_connection_manager_get_current_connection_info_cb (self, _sender, action);
}


#line 45 "rygel-connection-manager.vala"
static void rygel_connection_manager_real_constructed (GObject* base) {
#line 137 "rygel-connection-manager.c"
	RygelConnectionManager * self;
	char* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	self = (RygelConnectionManager*) base;
#line 46 "rygel-connection-manager.vala"
	self->sink_protocol_info = (_tmp0_ = g_strdup (""), _g_free0 (self->sink_protocol_info), _tmp0_);
#line 47 "rygel-connection-manager.vala"
	self->source_protocol_info = (_tmp1_ = g_strdup (""), _g_free0 (self->source_protocol_info), _tmp1_);
#line 48 "rygel-connection-manager.vala"
	self->connection_ids = (_tmp2_ = g_strdup ("0"), _g_free0 (self->connection_ids), _tmp2_);
#line 50 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SourceProtocolInfo", (GCallback) _rygel_connection_manager_query_source_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 52 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::SinkProtocolInfo", (GCallback) _rygel_connection_manager_query_sink_protocol_info_cb_gupnp_service_query_variable, self, 0);
#line 54 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "query-variable::CurrentConnectionIDs", (GCallback) _rygel_connection_manager_query_current_connection_ids_cb_gupnp_service_query_variable, self, 0);
#line 57 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetProtocolInfo", (GCallback) _rygel_connection_manager_get_protocol_info_cb_gupnp_service_action_invoked, self, 0);
#line 59 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionIDs", (GCallback) _rygel_connection_manager_get_current_connection_ids_cb_gupnp_service_action_invoked, self, 0);
#line 61 "rygel-connection-manager.vala"
	g_signal_connect_object ((GUPnPService*) self, "action-invoked::GetCurrentConnectionInfo", (GCallback) _rygel_connection_manager_get_current_connection_info_cb_gupnp_service_action_invoked, self, 0);
#line 161 "rygel-connection-manager.c"
}


#line 65 "rygel-connection-manager.vala"
static void rygel_connection_manager_query_source_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val) {
#line 65 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 65 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 65 "rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 68 "rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 69 "rygel-connection-manager.vala"
	g_value_set_string (val, self->source_protocol_info);
#line 177 "rygel-connection-manager.c"
}


#line 72 "rygel-connection-manager.vala"
static void rygel_connection_manager_query_sink_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val) {
#line 72 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 72 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 72 "rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 75 "rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 76 "rygel-connection-manager.vala"
	g_value_set_string (val, self->sink_protocol_info);
#line 193 "rygel-connection-manager.c"
}


#line 79 "rygel-connection-manager.vala"
static void rygel_connection_manager_query_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, const char* var, GValue* val) {
#line 79 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 79 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 79 "rygel-connection-manager.vala"
	g_return_if_fail (var != NULL);
#line 82 "rygel-connection-manager.vala"
	g_value_init (val, G_TYPE_STRING);
#line 83 "rygel-connection-manager.vala"
	g_value_set_string (val, self->connection_ids);
#line 209 "rygel-connection-manager.c"
}


#line 86 "rygel-connection-manager.vala"
static void rygel_connection_manager_get_protocol_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
#line 86 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 86 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 86 "rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 88 "rygel-connection-manager.vala"
	gupnp_service_action_set (action, "Source", G_TYPE_STRING, self->source_protocol_info, "Sink", G_TYPE_STRING, self->sink_protocol_info, NULL);
#line 91 "rygel-connection-manager.vala"
	gupnp_service_action_return (action);
#line 225 "rygel-connection-manager.c"
}


#line 94 "rygel-connection-manager.vala"
static void rygel_connection_manager_get_current_connection_ids_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
#line 94 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 94 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 94 "rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 96 "rygel-connection-manager.vala"
	gupnp_service_action_set (action, "ConnectionIDs", G_TYPE_STRING, self->connection_ids, NULL);
#line 98 "rygel-connection-manager.vala"
	gupnp_service_action_return (action);
#line 241 "rygel-connection-manager.c"
}


#line 101 "rygel-connection-manager.vala"
static void rygel_connection_manager_get_current_connection_info_cb (RygelConnectionManager* self, GUPnPService* cm, GUPnPServiceAction* action) {
#line 247 "rygel-connection-manager.c"
	gint connection_id = 0;
#line 101 "rygel-connection-manager.vala"
	g_return_if_fail (self != NULL);
#line 101 "rygel-connection-manager.vala"
	g_return_if_fail (cm != NULL);
#line 101 "rygel-connection-manager.vala"
	g_return_if_fail (action != NULL);
#line 105 "rygel-connection-manager.vala"
	gupnp_service_action_get (action, "ConnectionID", G_TYPE_INT, &connection_id, NULL);
#line 106 "rygel-connection-manager.vala"
	if (connection_id != 0) {
#line 107 "rygel-connection-manager.vala"
		gupnp_service_action_return_error (action, (guint) 706, _ ("Invalid connection reference"));
#line 109 "rygel-connection-manager.vala"
		return;
#line 263 "rygel-connection-manager.c"
	}
#line 112 "rygel-connection-manager.vala"
	gupnp_service_action_set (action, "RcsID", G_TYPE_INT, self->rcs_id, "AVTransportID", G_TYPE_INT, self->av_transport_id, "ProtocolInfo", G_TYPE_STRING, "", "PeerConnectionManager", G_TYPE_STRING, "", "PeerConnectionID", G_TYPE_INT, -1, "Direction", G_TYPE_STRING, self->direction, "Status", G_TYPE_STRING, "OK", NULL);
#line 134 "rygel-connection-manager.vala"
	gupnp_service_action_return (action);
#line 269 "rygel-connection-manager.c"
}


#line 31 "rygel-connection-manager.vala"
RygelConnectionManager* rygel_connection_manager_construct (GType object_type) {
#line 275 "rygel-connection-manager.c"
	RygelConnectionManager * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 31 "rygel-connection-manager.vala"
RygelConnectionManager* rygel_connection_manager_new (void) {
#line 31 "rygel-connection-manager.vala"
	return rygel_connection_manager_construct (RYGEL_TYPE_CONNECTION_MANAGER);
#line 286 "rygel-connection-manager.c"
}


static void rygel_connection_manager_class_init (RygelConnectionManagerClass * klass) {
	rygel_connection_manager_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructed = rygel_connection_manager_real_constructed;
	G_OBJECT_CLASS (klass)->finalize = rygel_connection_manager_finalize;
}


static void rygel_connection_manager_instance_init (RygelConnectionManager * self) {
}


static void rygel_connection_manager_finalize (GObject* obj) {
	RygelConnectionManager * self;
	self = RYGEL_CONNECTION_MANAGER (obj);
	_g_free0 (self->sink_protocol_info);
	_g_free0 (self->connection_ids);
	_g_free0 (self->source_protocol_info);
	_g_free0 (self->direction);
	G_OBJECT_CLASS (rygel_connection_manager_parent_class)->finalize (obj);
}


/**
 * Basic implementation of UPnP ConnectionManager service version 2.
 */
GType rygel_connection_manager_get_type (void) {
	static volatile gsize rygel_connection_manager_type_id__volatile = 0;
	if (g_once_init_enter (&rygel_connection_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (RygelConnectionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) rygel_connection_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (RygelConnectionManager), 0, (GInstanceInitFunc) rygel_connection_manager_instance_init, NULL };
		GType rygel_connection_manager_type_id;
		rygel_connection_manager_type_id = g_type_register_static (GUPNP_TYPE_SERVICE, "RygelConnectionManager", &g_define_type_info, 0);
		g_once_init_leave (&rygel_connection_manager_type_id__volatile, rygel_connection_manager_type_id);
	}
	return rygel_connection_manager_type_id__volatile;
}




